unit RS232_Relaisboard;

interface

type
  TRS232_Relaisboard = class
    procedure Connect;
    procedure Disconnect;
    function InitBoards: boolean;
    function SetRelais(Board, Relais, Status: integer): boolean;
    procedure SetRelaisDummy(Board, Relais, Status: integer);
    function ResumeDummySettings(Board: integer): boolean;
    function Zerobyte(Board: integer): boolean;
    function NOPCheck: boolean;
  end;

implementation

uses Main, SysUtils;

const
  SwitchTime: integer = 10;

var
  BoardStatus: array[1..2] of integer;

////////////////////////////////////////////////////////////////////////////////

{$REGION 'Initialisierung'}

procedure TRS232_Relaisboard.Connect;
begin

end;

procedure TRS232_Relaisboard.Disconnect;
begin

end;

function TRS232_Relaisboard.InitBoards: boolean;
begin
  InitBoards := True;
end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

{$REGION 'Board-Funktionen'}

function TRS232_Relaisboard.SetRelais(Board, Relais, Status: integer): boolean;
var
  Relais_address, Board_state, New_board_state: integer;
begin

  Main.Form1.StatusMessage('Setze Relais ' + IntToStr(Relais) +
    ' auf Board' + IntToStr(Board) + ': ' + IntToStr(Status));

  Relais_address := 1;

  case Relais of
    1: Relais_address := 1;
    2: Relais_address := 2;
    3: Relais_address := 4;
    4: Relais_address := 8;
    5: Relais_address := 16;
    6: Relais_address := 32;
    7: Relais_address := 64;
    8: Relais_address := 128;
  end;

  Board_state := BoardStatus[Board];

  if Status = 0 then
    New_board_state := Board_state and 65535 - Relais_address
  else
    New_board_state := Board_state or Relais_address;

  BoardStatus[Board] := New_board_state;
  Main.Form1.SetRelaisGUIState(Board, Relais, Status);

  SetRelais := True;

  Sleep(SwitchTime);

end;

procedure TRS232_Relaisboard.SetRelaisDummy(Board, Relais, Status: integer);
var
  Relais_address, Board_state, New_board_state: integer;
begin

  Main.Form1.StatusMessage('Setze Relais ' + IntToStr(Relais) +
    ' auf Board' + IntToStr(Board) + ': ' + IntToStr(Status) + ' (Dummy)');

  Relais_address := 1;

  case Relais of
    1: Relais_address := 1;
    2: Relais_address := 2;
    3: Relais_address := 4;
    4: Relais_address := 8;
    5: Relais_address := 16;
    6: Relais_address := 32;
    7: Relais_address := 64;
    8: Relais_address := 128;
  end;

  Board_state := BoardStatus[Board];

  if Status = 0 then
    New_board_state := Board_state and 65535 - Relais_address
  else
    New_board_state := Board_state or Relais_address;

  BoardStatus[Board] := New_board_state;
  Main.Form1.SetRelaisGUIState(Board, Relais, Status + 2);

end;

function TRS232_Relaisboard.ResumeDummySettings(Board: integer): boolean;
var
  I, Status, rest, division: integer;
begin

  Main.Form1.StatusMessage('bernehme Dummy-Status auf Board ' + IntToStr(Board));

  Status := BoardStatus[Board];

  for I := 1 to 8 do
  begin
    rest     := status div 2;
    division := status mod 2;
    Main.Form1.SetRelaisGUIState(Board, I, division);
    status := rest;
  end;

  ResumeDummySettings := True;

  Sleep(SwitchTime);

end;

function TRS232_Relaisboard.Zerobyte(Board: integer): boolean;
begin

  Main.Form1.StatusMessage('Alle Relais aus');

  BoardStatus[Board] := 0;
  Main.Form1.SetRelaisGUIStateZerobyte;

  Zerobyte := True;

  Sleep(SwitchTime);

end;

function TRS232_Relaisboard.NOPCheck: boolean;
begin

  Main.Form1.StatusMessage('NOP-Test');

  NOPCheck := True;

end;

{$ENDREGION}

////////////////////////////////////////////////////////////////////////////////

end.
